Public Member Functions | Static Public Member Functions

# BinNavi.API.reil.mono.InstructionGraph Class Reference

Lattice graph class where each node contains one REIL instructions. More...

Inherits com::zynamics::zylib::types::graphs::MutableDirectedGraph< InstructionGraphNode, InstructionGraphEdge >, and BinNavi::API::disassembly::IDirectedGraph< InstructionGraphNode, InstructionGraphEdge >.

List of all members.

## Public Member Functions
void | addEdge (final InstructionGraphEdge edge)
| Adds an edge to the graph.
void | addNode (final InstructionGraphNode node)
| Adds a node to the graph.
| InstructionGraph (final List< InstructionGraphNode > nodes, final List< InstructionGraphEdge > edges)
| Creates a new instruction graph.
void | removeEdge (final InstructionGraphEdge edge)
| Removes an edge from the graph.
void | removeNode (final InstructionGraphNode node)
| Removes a node from the graph.
String | toString ()
| A printable representation of the instruction graph.
## Static Public Member Functions
static InstructionGraph | create (final ReilGraph graph)
| Creates an instruction graph from a REIL graph.

## Detailed Description

Graph class that describes graphs with nodes that contain exactly one REIL instruction.

## Constructor & Destructor Documentation

BinNavi.API.reil.mono.InstructionGraph.InstructionGraph | ( | final List< InstructionGraphNode > | nodes,
|  | final List< InstructionGraphEdge > | edges |
| ) |  |  |

Creates a new instruction graph.

Parameters:

  | nodes | List of nodes to put into the graph.
  | edges | List of edges to put into the graph.

## Member Function Documentation

void BinNavi.API.reil.mono.InstructionGraph.addEdge | ( | final InstructionGraphEdge | edge | ) |

Adds an instruction edge to the instruction graph.

Parameters:

  | edge | The edge to add to the graph.

void BinNavi.API.reil.mono.InstructionGraph.addNode | ( | final InstructionGraphNode | node | ) |

Adds an instruction node to the instruction graph.

Parameters:

  | node | The node to add to the graph.

static InstructionGraph BinNavi.API.reil.mono.InstructionGraph.create | ( | final ReilGraph | graph | ) | `[static]`

Creates an instruction graph from a REIL graph.

Parameters:

  | graph | The REIL graph to convert.

Returns:
  The created instruction graph.

void BinNavi.API.reil.mono.InstructionGraph.removeEdge | ( | final InstructionGraphEdge | edge | ) |

Removes an instruction edge from the instruction graph.

Parameters:

  | edge | The edge to remove.

void BinNavi.API.reil.mono.InstructionGraph.removeNode | ( | final InstructionGraphNode | node | ) |

Removes an instruction node from the instruction graph.

Parameters:

  | node | The node to remove.

String BinNavi.API.reil.mono.InstructionGraph.toString | ( |  | ) |

Returns a string representation of the instruction graph.

Returns:
  A string representation of the instruction graph.